#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <math.h>
#include <dos.h>

//室
#define INIT    0x04
#define SLCTIN  0x08
//室
#define ACK     0x40

int CentronixBaseAdr;

void InitCentPort() //樠 
{
	int far *pointer = new (int far);
	pointer = (int*)MK_FP(0, 0x408);   //⠥    BIOS
	CentronixBaseAdr = *pointer;       //  
	outportb (CentronixBaseAdr, 0xff);
};

unsigned char ReadCentPort() //⥭ 室 
{
	return ( inportb(CentronixBaseAdr + 1) );
};

void WriteCentPort (unsigned char bits)
{
	outportb (CentronixBaseAdr + 2, bits ^ 0x0b); //  
	outportb (CentronixBaseAdr, 0xff);
};
//ᤢ   ॣ
void MoveData ()
{
	WriteCentPort (INIT);
	delay(1);
	WriteCentPort (0);
};
//८ࠧ ࠧ ࠧ鸞   祭
int ConvertImage (int byte)
{
	//                              abcdefg    (d=0)
	if ( byte == 0xEC) return 0; //'11101100'
	if ( byte == 0x60) return 1; //'01100000'
	if ( byte == 0xCA) return 2; //'11001010'
	if ( byte == 0xE2) return 3; //'11100010'
	if ( byte == 0x66) return 4; //'01100110'
	if ( byte == 0xA6) return 5; //'10100110'
	if ( byte == 0xAE) return 6; //'10101110'
	if ( byte == 0xE0) return 7; //'11100000'
	if ( byte == 0xEE) return 8; //'11101110'
	if ( byte == 0xE6) return 9; //'11100110'
	return 0xFF; //訡 뢠
};
//饫   ॣ
void Strob ()
{
	WriteCentPort (SLCTIN);
	delay(1);
	WriteCentPort (0); //RD = 1
}
//뢠  ॣ  
int ReadLCD ()
{
	int LCD = 0; //ॠ쭮 ᯮ ⮫쪮  8 
	for (int i = 0; i < 8; i++)
	{
		LCD >>= 1; //ᤢ
		if ( !(ReadCentPort () & ACK) ) LCD |= 0x80; //⠭ ᥤ쬮 
		MoveData ();
	};
	return LCD;
}
//⫠筠 
void Debug (int i1, int i2, int i3)
{
	char str[200]; str[0] = 0;
	int i;
	strcat (str, "LCD1:(");
	//८ࠧ   ப 㫥  
	for (i = 0; i < 8; i++)
	{
		if ( i1 & 0x80 ) strcat (str, "1");
		else strcat (str, "0");
		i1 <<= 1;
	}
	strcat (str, ") LCD2:(");
	for (i = 0; i < 8; i++)
	{
		if ( i2 & 0x80 ) strcat (str, "1");
		else strcat (str, "0");
		i2 <<= 1;
	}
	strcat (str, ") LCD3:(");
	for (i = 0; i < 8; i++)
	{
		if ( i3 & 0x80 ) strcat (str, "1");
		else strcat (str, "0");
		i3 <<= 1;
	}
	strcat (str, ") ");
	printf ("%s  ", str);
}

float ReadMultim (int &KF, int debug)
{
	Strob ();
	int LCD1 = ReadLCD (); //뢠   DD3
	int LCD2 = ReadLCD (); //뢠   DD2
	int LCD3 = ReadLCD (); //뢠   DD1

	if ( debug ) Debug (LCD1, LCD2, LCD3); //᫨ 祭 ० ⫠

	int NUM1 = 0;
	int NUM2 = 0;
	int NUM3 = 0;
	int NUM4 = 0;
	int ZNAK = 0;

	if ( LCD1 & 0x01 ) //㥬  ᫨ BP = 1 (  ⠥)
	{
		LCD1 = ~LCD1;
		LCD2 = ~LCD2;
		LCD3 = ~LCD3;
	} else
	{
		//᫨ BP = 0   
		KF = 1;
		if ( LCD3 & 0x10 ) KF = 100;
		if ( LCD2 & 0x10 ) KF = 10;
	};

	if ( LCD2 & 0x01 ) ZNAK = 1; else ZNAK = 0; //⠥ 
	if ( LCD3 & 0x01 ) NUM1 = 1; else NUM1 = 0; //⠥  ࠧ AB4

	//뢠  4   0 -    뢠
	LCD1 &= 0xEE; LCD2 &= 0xEE; LCD3 &= 0xEE;
	//८ࠧ㥬  祭 ⠫ ࠧ
	NUM2 = ConvertImage (LCD1);
	NUM3 = ConvertImage (LCD2);
	NUM4 = ConvertImage (LCD3);

	//஢ઠ ८ࠧ  訡
	if ( (NUM2 == 0xFF) ||
	     (NUM3 == 0xFF) ||
	     (NUM4 == 0xFF) )
	{
		if ( debug ) printf (" Error ");
		return 0;
	}

	//८ࠧ㥬 ⠭   祭  
	float value = NUM1 * 1000 + NUM2 * 100 + NUM3 * 10 + NUM4;
	if ( ZNAK ) value = -value;
	value = value / KF;
	return value;
}

// ⫠筠 ணࠬ
void main ()
{
	InitCentPort ();

	int KF;
	int debug = 1;
	for (;;)
	{
		printf ("value = %4.2f\n", ReadMultim (KF, debug));
		if ( kbhit() ) break;
	};
};

